import { Record, Dictionary } from '@preserves/core';
import * as M from './gen/schema';

export const BASE: M.Schema = M.asSchema(Record(M.$schema, [new Dictionary<never>([
    [M.$version, 1],
    [M.$pointer, false],
    [M.$definitions, new Dictionary<never, M.Alternative>([
        [Symbol.for('any'), Record(M.$and, [[] as M.Pattern[]])],
        [Symbol.for('bool'), Record(M.$atom, [M.$Boolean])],
        [Symbol.for('float'), Record(M.$atom, [M.$Float])],
        [Symbol.for('double'), Record(M.$atom, [M.$Double])],
        [Symbol.for('int'), Record(M.$atom, [M.$SignedInteger])],
        [Symbol.for('string'), Record(M.$atom, [M.$String])],
        [Symbol.for('bytes'), Record(M.$atom, [M.$ByteString])],
        [Symbol.for('symbol'), Record(M.$atom, [M.$Symbol])],
        [Symbol.for('ref'), Record(M.$pointer, [])],
    ])],
])]));
